SystemOrganization addCategory: #RemoteDebugger!
SystemOrganization addCategory: #'RemoteDebugger-GUI'!
SystemOrganization addCategory: #'RemoteDebugger-Utilities'!

ByteArray variableByteSubclass: #RDBGIPAddress
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger-Utilities'!

!RDBGIPAddress class methodsFor: 'instance creation' stamp: 'LionelLi 4/21/2013 19:07'!
fromString: aString
	"return a new IP address from a string
	IPAddress fromString: '10.1.10.115'"
	
	^ self newFrom: ((aString findTokens: $.) collect: [:s | s asInteger])! !

!RDBGIPAddress class methodsFor: 'instance creation' stamp: 'LionelLi 4/21/2013 19:03'!
local
	"mp 10/30/2005 15:53"
	"return a new IP address from a string
	IPAddress local"
	
	^ self newFrom: NetNameResolver localHostAddress! !

!RDBGIPAddress class methodsFor: 'instance creation' stamp: 'LionelLi 4/21/2013 19:03'!
netID1: anInteger1 netID2: anInteger2 hostID1: anInteger3 hostID2: anInteger4
	"mp 10/6/2005 18:53"
	"Return an instance with the 4 bytes of an IP address
	IPAddress netID1: 10 netID2: 1 hostID1: 10 hostID2: 115"
	
	^ self 
		with: anInteger1
		with: anInteger2
		with: anInteger3
		with: anInteger4! !

!RDBGIPAddress methodsFor: 'converting' stamp: 'LionelLi 4/21/2013 19:05'!
asString
	^ NetNameResolver stringFromAddress: self! !

!RDBGIPAddress methodsFor: 'converting' stamp: 'LionelLi 4/21/2013 19:05'!
asSymbol
	^ self asString asSymbol! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
hostID1
	"mp 10/6/2005 19:53"
	
	^ self third! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
hostID1: anInteger
	"mp 10/6/2005 19:53"
	
	self at: 3 put: anInteger! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
hostID2
	"mp 10/6/2005 19:53"
	
	^ self fourth! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
hostID2: anInteger
	"mp 10/6/2005 19:53"
	
	self at: 4 put: anInteger! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
netID1
	"mp 10/6/2005 19:53"
	
	^ self first! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
netID1: anInteger
	"mp 10/6/2005 19:53"
	
	self at: 1 put: anInteger! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
netID2
	"mp 10/6/2005 19:53"
	
	^ self second! !

!RDBGIPAddress methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:03'!
netID2: anInteger
	"mp 10/6/2005 19:53"
	
	self at: 2 put: anInteger! !

!RDBGIPAddress methodsFor: 'arithmetic' stamp: 'LionelLi 4/21/2013 19:03'!
next
	"mp 10/7/2005 14:57"
	
	self nextHostID2! !

!RDBGIPAddress methodsFor: 'arithmetic' stamp: 'LionelLi 4/21/2013 19:03'!
nextHostID1
	"mp 12/19/2005 16:32"
	| gap |
	self hostID1 >= 255
		ifTrue: [gap := self hostID1 - 255.
			0
				to: gap
				do: [:n | self nextNetID2].
			self hostID1: gap]
		ifFalse: [self hostID1: self hostID1 + 1]! !

!RDBGIPAddress methodsFor: 'arithmetic' stamp: 'LionelLi 4/21/2013 19:03'!
nextHostID2
	"mp 12/19/2005 16:32"
	| gap |
	self hostID2 >= 255
		ifTrue: [gap := self hostID2 - 255.
			0
				to: gap
				do: [:n | self nextHostID1].
			self hostID2: gap]
		ifFalse: [self hostID2: self hostID2 + 1]! !

!RDBGIPAddress methodsFor: 'arithmetic' stamp: 'LionelLi 4/21/2013 19:03'!
nextNetID1
	"mp 12/19/2005 16:30"
	self netID1 >= 255
		ifTrue: [UTMaximumIPReached signal]
		ifFalse: [self netID1: self netID1 + 1]! !

!RDBGIPAddress methodsFor: 'arithmetic' stamp: 'LionelLi 4/21/2013 19:03'!
nextNetID2
	"mp 12/19/2005 16:32"
	| gap |
	self netID2 >= 255
		ifTrue: [gap := self netID2 - 255.
			0
				to: gap
				do: [:n | self nextNetID1].
			self netID2: gap]
		ifFalse: [self netID2: self netID2 + 1]! !

Object subclass: #RDBGClient
	instanceVariableNames: 'hostname ipAddress servicePort isRunning status remoteHostId hostId remoteHostProxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger'!

RDBGClient class
	instanceVariableNames: 'instance'!

RDBGClient class
	instanceVariableNames: 'instance'!

!RDBGClient class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 20:42'!
defaultHostID
	^RDBGHostID fromString: (RDBGClient defaultHostname, '@', NetNameResolver localAddressString, ':', RDBGClient defaultServicePort asString)
! !

!RDBGClient class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 20:25'!
defaultHostname
	^'$rDBG-Client'! !

!RDBGClient class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 20:25'!
defaultServicePort
	^7777
! !

!RDBGClient class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:21'!
initialize! !

!RDBGClient class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:21'!
instance
	^instance ifNil: [instance := super new]! !

!RDBGClient class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:21'!
new
	self error: 'Only one instance of proxy can be created.'! !

!RDBGClient class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:21'!
reset
	RSTBroker reset.
	^ instance ifNotNil: [instance stop. instance := nil]! !

!RDBGClient class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 20:45'!
show
	RDBGClient reset.
	^ RDBGClientGUI open! !

!RDBGClient class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:21'!
shutDown
	(instance notNil and: [instance isRunning])
		ifTrue: [instance stop] ! !

!RDBGClient class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:21'!
startUp
	|inst|
	inst := self instance.
	(instance notNil and: [instance isRunning = false])
		ifTrue: [instance start]! !

!RDBGClient methodsFor: 'testing' stamp: 'LionelLi 4/22/2013 00:58'!
connectTo: aHostID
	|tempProxy success|
	success := false.
	remoteHostProxy ifNotNil: [Transcript show: 'Remote host proxy is already connected'. ^false].
	[tempProxy := (RSTRemoteObjectID fromString: (aHostID asString)) asProxy.
	success := tempProxy registerRemoteClient: (self hostID)]
	on: RSTRemoteObjectUnreachable do: [
		Transcript show: 'Error connecting to remote host ', aHostID asString.
		^false
	].
	
	success ifTrue: [
		remoteHostProxy := tempProxy.
		self status: 1.
	].
	^ success.
! !

!RDBGClient methodsFor: 'testing' stamp: 'LionelLi 4/21/2013 21:27'!
connectToRemoteHost
	^self connectTo: remoteHostId! !

!RDBGClient methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:21'!
export
	RSTBroker instance export: self named: self hostname! !

!RDBGClient methodsFor: 'accessing' stamp: 'LionelLi 4/22/2013 00:09'!
getStatusAsString
	|statusString|
	status = -1 ifTrue: [ statusString := 'Disconnected' ].
	status = 0 ifTrue: [ statusString := 'Listening to port ', servicePort asString ].
	status = 1 ifTrue: [ statusString := 'Connected to ', remoteHostId asStringID].
	^statusString.! !

!RDBGClient methodsFor: 'accessing' stamp: 'LionelLi 4/22/2013 03:00'!
handleException: aString
	| objException objLocation |
	objLocation := aString, '@', remoteHostId asStringID.
	Transcript show: objLocation.
	objException := objLocation asLocalObject.
	objException explore.
"	Smalltalk tools debugError: objException."
! !

!RDBGClient methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 20:32'!
hostID
	^hostId! !

!RDBGClient methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 21:19'!
hostname
	^hostname ifNil: [hostname := RDBGClient defaultHostname]! !

!RDBGClient methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 18:21'!
hostname: aString
	hostname := aString! !

!RDBGClient methodsFor: 'initialize-release' stamp: 'LionelLi 4/21/2013 20:30'!
initialize
	super initialize.
	status := -1.
	isRunning := false.
	hostId := RDBGClient defaultHostID.
	remoteHostId := RDBGProxy defaultHostID.
! !

!RDBGClient methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:55'!
ipAddress
	^ipAddress! !

!RDBGClient methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:55'!
ipAddress: aString
	ipAddress := aString! !

!RDBGClient methodsFor: 'testing' stamp: 'LionelLi 4/21/2013 18:21'!
isRunning
	^isRunning! !

!RDBGClient methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:21'!
printClientMessage: anObject
	Transcript show: ('RemoteClient: ', anObject); cr.
	anObject inspect
! !

!RDBGClient methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 20:36'!
remoteHostID
	^ remoteHostId! !

!RDBGClient methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 21:19'!
servicePort
	^servicePort ifNil: [servicePort :=RDBGClient defaultServicePort]! !

!RDBGClient methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 18:21'!
servicePort: anInteger
	servicePort := anInteger.! !

!RDBGClient methodsFor: 'start/stop' stamp: 'LionelLi 4/21/2013 19:58'!
start
	self startRST.
	self export.
	isRunning := true.
	status := 0.
	Transcript show: 'Starting rDBGClient...'; cr.
! !

!RDBGClient methodsFor: 'start/stop' stamp: 'LionelLi 4/21/2013 21:41'!
startRST
	RSTBroker startOnPort: (self hostID port) logging: false! !

!RDBGClient methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 18:21'!
status
	"Get status.
	    -1: Disconnected
	    0: Listening
	    1: Connected"

	^status ifNil: [status := -1]! !

!RDBGClient methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 18:21'!
status: anInteger
	"Set status.
	    -1: Disconnected
	    0: Listening
	    1: Connected"

	status := anInteger! !

!RDBGClient methodsFor: 'start/stop' stamp: 'LionelLi 4/21/2013 21:01'!
stop
	remoteHostProxy ifNotNil: ["Notify client that proxy is disconnecting"].
	self stopRST.
	isRunning := false.
	status := -1.
	Transcript show: 'Stopping rDBGClient...'; cr.
! !

!RDBGClient methodsFor: 'start/stop' stamp: 'LionelLi 4/21/2013 18:21'!
stopRST
	RSTBroker stop
! !

Object subclass: #RDBGClientGUI
	instanceVariableNames: 'mainWindow ctlAddress ctlPort ctlStatus client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger-GUI'!

RDBGClientGUI class
	instanceVariableNames: 'instance'!

RDBGClientGUI class
	instanceVariableNames: 'instance'!

!RDBGClientGUI class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 19:41'!
instance
	instance ifNil: [instance := self new].
	^instance! !

!RDBGClientGUI class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 19:40'!
open
	self instance open.! !

!RDBGClientGUI methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:22'!
client
	^ RDBGClient instance! !

!RDBGClientGUI methodsFor: 'callbacks' stamp: 'LionelLi 4/21/2013 18:40'!
connectButtonEnabled
	^true
! !

!RDBGClientGUI methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:40'!
onCloseButtonClick
	RDBGClient shutDown.
	self updateConnectionStatus: self client getStatusAsString.
	"Add code to disconnect RSTBroker and clean up"
	mainWindow delete.
	Transcript show: 'Close button clicked'; cr.
! !

!RDBGClientGUI methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 23:45'!
onConnectButtonClick
	|success|
	"TODO: Do some field validation and prompt user if there is error"
	self client start.
	success := self client connectToRemoteHost.
	success ifFalse: [
		UIManager default inform: 'Connection failed'
	].

	Transcript show: 'Connect button clicked'; cr.
	self updateConnectionStatus: self client getStatusAsString.
! !

!RDBGClientGUI methodsFor: 'display' stamp: 'LionelLi 4/21/2013 20:48'!
open
	|builder content dialog statusString |
	statusString := self client getStatusAsString.
	builder := UITheme builder.
	content := builder newColumn: {
		builder newLabelGroup: {
			'Host address' -> (ctlAddress := ((builder newTextEntryFor: (self client remoteHostID) getText: #ipAddress setText: nil help: 'Host name') minWidth: 200)).
			'Connect to port' -> (ctlPort := builder newTextEntryFor: (self client remoteHostID) getText: #port setText: nil help: 'Port number').
			'Status ' -> (ctlStatus := (builder newLabel: statusString)).
		}.
		(builder newRow: {
			(builder newButtonFor: self action: #onConnectButtonClick getEnabled: #connectButtonEnabled label: 'Connect' help: 'Connect to address').
			(builder newButtonFor: self action: #onCloseButtonClick getEnabled: nil label: 'Close' help: 'Disconnect and close remote debugger').
		} ) listCentering: #bottomRight
	}.

	mainWindow := (content openInWindowLabeled: self title) extent: 400@130.
! !

!RDBGClientGUI methodsFor: 'display' stamp: 'LionelLi 4/21/2013 18:47'!
title
	^'RDBG Client Connection'.! !

!RDBGClientGUI methodsFor: 'display' stamp: 'LionelLi 4/21/2013 19:10'!
updateConnectionStatus: aString
	ctlStatus contents: aString! !

Object subclass: #RDBGHostID
	instanceVariableNames: 'hostname ipAddress port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger-Utilities'!

!RDBGHostID class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 19:12'!
fromString: aString	
	^ self new fromString: aString! !

!RDBGHostID class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:59'!
hostname: aString ipAddress: anIP port: anInteger
	^ (self new) hostname: aString; ipAddress: anIP; port: anInteger.
! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:13'!
= aHostID
	^ (self hostname = aHostID hostname) and:
		[(self ipAddress = aHostID ipAddress) and: 
			[self port = aHostID port]]! !

!RDBGHostID methodsFor: 'converting' stamp: 'LionelLi 4/21/2013 19:00'!
asString
	^ self hostname, '@', self ipAddress asString, ':', self port asString! !

!RDBGHostID methodsFor: 'converting' stamp: 'LionelLi 4/21/2013 19:15'!
asStringID
	^ self ipAddress asString , ':' , self port asString! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:13'!
fromString: aString 
	| tokens |
	tokens := aString findTokens: '@:'.
	self hostname: tokens first.
	self ipAddress: (RDBGIPAddress fromString: tokens second).
	self port: tokens third asInteger
! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:15'!
hash
	^ self hostname hash bitXor: 
		(self ipAddress hash bitXor: self port hash).
! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:14'!
hostAtIP
	"return a string in the form 'host@127.0.0.1'"
	
	^ self hostname , '@' , self ipAddress asString! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:01'!
hostname
	^hostname! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:01'!
hostname: aString
	hostname := aString! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:01'!
ipAddress
	^ipAddress! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:06'!
ipAddress: anIPAddress
	ipAddress := anIPAddress! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:02'!
port
	^port! !

!RDBGHostID methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 19:02'!
port: anInteger
	port := anInteger! !

Object subclass: #RDBGProxy
	instanceVariableNames: 'hostname servicePort isRunning status clientProxy clientHostId hostId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger'!

RDBGProxy class
	instanceVariableNames: 'instance'!

RDBGProxy class
	instanceVariableNames: 'instance'!

!RDBGProxy class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 20:43'!
defaultHostID
	^RDBGHostID fromString: (RDBGProxy defaultHostname, '@', NetNameResolver localAddressString, ':', RDBGProxy defaultServicePort asString)
! !

!RDBGProxy class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 20:24'!
defaultHostname
	^'$rDBG-Proxy'! !

!RDBGProxy class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 20:25'!
defaultServicePort
	^6666
! !

!RDBGProxy class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/16/2013 02:30'!
initialize! !

!RDBGProxy class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 17:06'!
instance
	^instance ifNil: [instance := super new]! !

!RDBGProxy class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 15:29'!
new
	self error: 'Only one instance of proxy can be created.'! !

!RDBGProxy class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 15:30'!
reset
	RSTBroker reset.
	^ instance ifNotNil: [instance stop. instance := nil]! !

!RDBGProxy class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 19:48'!
show
	^ RDBGProxyGUI open! !

!RDBGProxy class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/16/2013 02:43'!
shutDown
	(instance notNil and: [instance isRunning])
		ifTrue: [instance stop] ! !

!RDBGProxy class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 16:47'!
startUp
	|inst|
	inst := self instance.
	(instance notNil and: [instance isRunning = false])
		ifTrue: [instance start]! !

!RDBGProxy methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/16/2013 02:13'!
export
	RSTBroker instance export: self named: self hostname! !

!RDBGProxy methodsFor: 'accessing' stamp: 'LionelLi 4/22/2013 00:55'!
getStatusAsString
	|statusString|
	status = -1 ifTrue: [ statusString := 'Disconnected' ].
	status = 0 ifTrue: [ statusString := 'Listening to port ', self hostID port asString ].
	status = 1 ifTrue: [ statusString := 'Connected to ', clientHostId asStringID].
	^statusString.! !

!RDBGProxy methodsFor: 'initialize-release' stamp: 'LionelLi 4/21/2013 21:34'!
hostID
	^hostId ifNil: [hostId := RDBGProxy defaultHostID]! !

!RDBGProxy methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 21:32'!
hostname
	^hostname ifNil: [hostname := RDBGProxy defaultHostname]! !

!RDBGProxy methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 16:56'!
hostname: aString
	hostname := aString! !

!RDBGProxy methodsFor: 'initialize-release' stamp: 'LionelLi 4/21/2013 21:52'!
initialize
	super initialize.
	status := -1.
	isRunning := false.
	hostId := RDBGProxy defaultHostID.
! !

!RDBGProxy methodsFor: 'testing' stamp: 'LionelLi 4/16/2013 02:46'!
isRunning
	^isRunning! !

!RDBGProxy methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/22/2013 02:49'!
notifyClientOf: anException
	RSTBroker export: anException named: 'exception' .
	clientProxy handleException: 'exception'.
! !

!RDBGProxy methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/16/2013 03:34'!
printClientMessage: anObject
	Transcript show: ('RemoteClient: ', anObject); cr.
	anObject inspect
! !

!RDBGProxy methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/22/2013 02:10'!
registerRemoteClient: aHostID
	clientProxy ifNotNil: [^false].

	[clientHostId := (RDBGHostID new) hostname: aHostID hostname; port: aHostID port; ipAddress: aHostID ipAddress.
	clientProxy := ((RSTRemoteObjectID) fromString: (clientHostId asString)) asProxy]
	on: RSTRemoteObjectUnreachable do: [^false].
	status := 1.
	RDBGProxyGUI instance updateConnectionStatus: self getStatusAsString.
	^true
! !

!RDBGProxy methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 21:32'!
servicePort
	^servicePort ifNil: [servicePort := RDBGProxy defaultServicePort]! !

!RDBGProxy methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 16:54'!
servicePort: anInteger
	servicePort := anInteger.! !

!RDBGProxy methodsFor: 'start/stop' stamp: 'LionelLi 4/21/2013 17:14'!
start
	self startRST.
	self export.
	isRunning := true.
	status := 0.
	Transcript show: 'Starting rDBGProxy...'; cr.
! !

!RDBGProxy methodsFor: 'start/stop' stamp: 'LionelLi 4/21/2013 21:41'!
startRST
	RSTBroker startOnPort: (self hostID port) logging: false! !

!RDBGProxy methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 17:13'!
status
	"Get status.
	    -1: Disconnected
	    0: Listening
	    1: Connected"

	^status ifNil: [status := -1]! !

!RDBGProxy methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 17:13'!
status: anInteger
	"Set status.
	    -1: Disconnected
	    0: Listening
	    1: Connected"

	status := anInteger! !

!RDBGProxy methodsFor: 'start/stop' stamp: 'LionelLi 4/21/2013 19:17'!
stop
	clientHostId ifNotNil: ["Notify client that proxy is disconnecting"].
	self stopRST.
	isRunning := false.
	status := -1.
	Transcript show: 'Stopping rDBGProxy...'; cr.
! !

!RDBGProxy methodsFor: 'start/stop' stamp: 'LionelLi 4/16/2013 02:02'!
stopRST
	RSTBroker stop
! !

Object subclass: #RDBGProxyGUI
	instanceVariableNames: 'hostName portNumber ctlAddress ctlPort ctlStatus mainWindow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger-GUI'!

RDBGProxyGUI class
	instanceVariableNames: 'instance'!

RDBGProxyGUI class
	instanceVariableNames: 'instance'!

!RDBGProxyGUI class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 19:39'!
instance
	instance ifNil: [instance := self new hostName: 'localhost'].
	^instance! !

!RDBGProxyGUI class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 19:39'!
open
	self instance open.! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 17:20'!
connectButtonEnabled
	^ true.! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 15:39'!
host
	^ RDBGProxy instance! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 04:15'!
hostName
	^ NetNameResolver localAddressString! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 04:04'!
hostName: aString
	hostName := aString! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 21:52'!
initialize
! !

!RDBGProxyGUI methodsFor: 'callbacks' stamp: 'LionelLi 4/21/2013 17:30'!
onCloseButtonClick
	RDBGProxy shutDown.
	self updateConnectionStatus: self host getStatusAsString.
	"Add code to disconnect RSTBroker and clean up"
	mainWindow delete.
	Transcript show: 'Close button clicked'; cr.
! !

!RDBGProxyGUI methodsFor: 'callbacks' stamp: 'LionelLi 4/21/2013 21:55'!
onConnectButtonClick
	Transcript show: 'Connect button clicked'; cr.
	self updateModelValues.
	RDBGProxy startUp.
	self updateConnectionStatus: self host getStatusAsString.! !

!RDBGProxyGUI methodsFor: 'display' stamp: 'LionelLi 4/21/2013 22:05'!
open
	|builder content dialog statusString |
	statusString := self host getStatusAsString.
	builder := UITheme builder.
	content := builder newColumn: {
		builder newLabelGroup: {
			'Host address' -> ((builder newTextEntryFor: (self host hostID) getText: #ipAddress setText: #ipAddress: help: 'Host name') disable; minWidth: 200).
			'Listen to port' -> (ctlPort := builder newTextEntryFor: (self host hostID) getText: #port setText: #port: help: 'Port number').
			'Status ' -> (ctlStatus := (builder newLabel: statusString)).
		}.
		(builder newRow: {
			(builder newButtonFor: self action: #onConnectButtonClick getEnabled: #connectButtonEnabled label: 'Connect' help: 'Connect to address').
			(builder newButtonFor: self action: #onCloseButtonClick getEnabled: nil label: 'Close' help: 'Disconnect and close remote debugger').
		} ) listCentering: #bottomRight
	}.

"	dialog := builder newPluggableDialogWindow: 'Proxy Connection Window'  for: content.
	dialog useOKDefaultCancelButton.
	dialog rememberKeyboardFocus: ctlPort.
	builder openModal: dialog.
"
	mainWindow := (content openInWindowLabeled: self title) extent: 400@130; rememberKeyboardFocus: ctlPort.
! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 15:09'!
portNumber
	^portNumber ifNil: [portNumber := '9999']! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 04:04'!
portNumber: aString
	portNumber := aString asInteger! !

!RDBGProxyGUI methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:42'!
title
	^ 'rDBG Proxy Connection'! !

!RDBGProxyGUI methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 15:07'!
updateConnectionStatus: aString
	ctlStatus contents: aString! !

!RDBGProxyGUI methodsFor: 'callbacks' stamp: 'LionelLi 4/21/2013 22:05'!
updateModelValues
	self host hostID port: ctlPort getText asInteger.
! !
RDBGClient initialize!
RDBGProxy initialize!
